%define major 11
%define libname %mklibname gcrypt %{major}
%define develname %mklibname gcrypt -d

# disable tests by default, no /dev/random feed, no joy
%define do_check 1
%{expand: %{?_with_check: %%global do_check 1}}

Summary:	GNU Cryptographic library
Name:		libgcrypt
Version:	1.5.4
%define subrel	5
Release:	%mkrel 5
License:	LGPLv2+
Group:		System/Libraries
Url:		http://www.gnupg.org/
# don't convert to bzip2, since we ship archive signature
Source0:	ftp://ftp.gnupg.org/gcrypt/libgcrypt/%{name}-%{version}.tar.bz2
Source1:	ftp://ftp.gnupg.org/gcrypt/libgcrypt/%{name}-%{version}.tar.bz2.sig
Patch1:		libgcrypt-1.2.0-libdir.patch
Patch2:		libgcrypt-1.5.4-CVE-2014-3591.patch
Patch3:		libgcrypt-1.5.4-CVE-2015-0837.patch
Patch4:		0001-rsa-Add-verify-after-sign-to-avoid-Lenstra-s-CRT-att.patch
Patch5:		libgcrypt-1.5.4-CVE-2015-7511.patch
Patch6:		18_random-Improve-the-diagram-showing-the-random-mixing.patch
Patch7:		19_random-Hash-continuous-areas-in-the-csprng-pool.patch
Patch8:		libgcrypt-1.5.3-CVE-2017-7526-1.patch
Patch9:		libgcrypt-1.5.3-CVE-2017-7526-2.patch
Patch10:	libgcrypt-1.5.3-CVE-2017-7526-3.patch
Patch11:	libgcrypt-1.5.3-CVE-2017-7526-4.patch
Patch12:	libgcrypt-1.5.3-CVE-2017-7526-5.patch
Patch13:	CVE-2018-0495.patch
BuildRequires:	libgpg-error-devel >= 0.5
BuildRequires:	pth-devel

%description
Libgcrypt is a general purpose cryptographic library
based on the code from GNU Privacy Guard.  It provides functions for all
cryptograhic building blocks: symmetric ciphers
(AES,DES,Blowfish,CAST5,Twofish,Arcfour), hash algorithms (MD5,
RIPE-MD160, SHA-1, TIGER-192), MACs (HMAC for all hash algorithms),
public key algorithms (RSA, ElGamal, DSA), large integer functions,
random numbers and a lot of supporting functions.

%package -n %{libname}
Summary:	GNU Cryptographic library
Group:		System/Libraries
Provides:	%{name} = %{version}-%{release}

%description -n %{libname}
Libgcrypt is a general purpose cryptographic library
based on the code from GNU Privacy Guard.  It provides functions for all
cryptograhic building blocks: symmetric ciphers
(AES,DES,Blowfish,CAST5,Twofish,Arcfour), hash algorithms (MD5,
RIPE-MD160, SHA-1, TIGER-192), MACs (HMAC for all hash algorithms),
public key algorithms (RSA, ElGamal, DSA), large integer functions,
random numbers and a lot of supporting functions.

%package -n %{develname}
Summary:	Development files for GNU cryptographic library
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%mklibname -d gcrypt 11

%description -n %{develname}
Libgcrypt is a general purpose cryptographic library
based on the code from GNU Privacy Guard.
This package contains files needed to develop
applications using libgcrypt. ( For example Ägypten project )

%prep
%setup -q
%patch1 -p1 -b .libdir
%patch2 -p1 -b .CVE-2014-3591
%patch3 -p1 -b .CVE-2015-0837
%patch4 -p1
%patch5 -p1 -b .CVE-2015-7511
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1

%build
%configure2_5x --disable-static \
	--disable-dev-random \
	--enable-random-daemon \
	--enable-m-guard
%make

%check
%if %{do_check}
make check
%endif

%install
%makeinstall_std

find %{buildroot} -name '*.la' -delete

mv $RPM_BUILD_ROOT/%{_sbindir}/gcryptrnd $RPM_BUILD_ROOT/%{_bindir}/gcryptrnd
%multiarch_binaries $RPM_BUILD_ROOT/%{_bindir}/gcryptrnd

%post -n %{develname}
%_install_info %{name}.info

%postun -n %{develname}
%_remove_install_info %{name}.info

%files -n %{libname}
%doc AUTHORS README NEWS THANKS TODO
%multiarch %{multiarch_bindir}/gcryptrnd
%{_libdir}/lib*.so.%{major}
%{_libdir}/lib*.so.%{major}.*

%files -n %{develname}
%doc ChangeLog README.*
%{_bindir}/*
%{_includedir}/*.h
%{_libdir}/lib*.so
%{_datadir}/aclocal/*
%{_infodir}/gcrypt.info*


%changelog
* Thu Jun 21 2018 wally <wally> 1.5.4-5.5.mga5
  (not released yet)
+ Revision: 1238531
- add patch from ubunto to fix CVE-2018-0495 (mga#23210)

* Sat Jul 08 2017 luigiwalser <luigiwalser> 1.5.4-5.4.mga5
+ Revision: 1109559
- add patches from ubuntu to fix CVE-2017-7526

* Thu Aug 18 2016 luigiwalser <luigiwalser> 1.5.4-5.3.mga5
+ Revision: 1046910
- add patches from debian to fix CVE-2016-6313

* Fri Feb 12 2016 luigiwalser <luigiwalser> 1.5.4-5.2.mga5
+ Revision: 958838
- add patch from upstream via gentoo to fix CVE-2015-7511
- add patch from opensuse to fix issue related to CVE-2015-5738

* Wed Apr 01 2015 luigiwalser <luigiwalser> 1.5.4-5.mga5
+ Revision: 819552
- add patch from ubuntu to fix CVE-2015-0837

* Fri Mar 06 2015 luigiwalser <luigiwalser> 1.5.4-4.mga5
+ Revision: 817945
- add upstream patch to fix CVE-2014-3591

* Wed Oct 15 2014 umeabot <umeabot> 1.5.4-3.mga5
+ Revision: 744285
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.5.4-2.mga5
+ Revision: 681474
- Mageia 5 Mass Rebuild

* Mon Aug 11 2014 luigiwalser <luigiwalser> 1.5.4-1.mga5
+ Revision: 661714
- 1.5.4 (fixes elgamal side-channel attack)

* Sat Oct 19 2013 umeabot <umeabot> 1.5.3-2.mga4
+ Revision: 530654
- Mageia 4 Mass Rebuild

* Sat Jul 27 2013 boklm <boklm> 1.5.3-1.mga4
+ Revision: 458790
- Version 1.5.3 (CVE-2013-4242)

* Thu Jun 13 2013 fwang <fwang> 1.5.2-1.mga4
+ Revision: 442314
- new version 1.5.2

* Sat Jan 12 2013 umeabot <umeabot> 1.5.0-3.mga3
+ Revision: 357154
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 15 2011 fwang <fwang> 1.5.0-2.mga2
+ Revision: 181706
- drop .la files
- disable static
- new version 1.5.0

* Sat Jan 08 2011 blino <blino> 1.4.6-4.mga1
+ Revision: 510
- remove obsolete postun
- imported package libgcrypt


* Sat Jul 17 2010 Lonyai Gergely <aleph@mandriva.org> 1.4.6-3mdv2011.0
+ Revision: 554586
- Multiarch fix 2.

* Sat Jul 17 2010 Lonyai Gergely <aleph@mandriva.org> 1.4.6-2mdv2011.0
+ Revision: 554472
- gcryptrnd mv into %%_bindir from %%_sbindir
- Fix a multiarch problem

* Thu Jul 15 2010 Lonyai Gergely <aleph@mandriva.org> 1.4.6-1mdv2011.0
+ Revision: 553560
- Add BuildRequires libpth-devel
- 1.4.6
  Enable internal random generator
  Enable m-guard facility

* Sat Dec 12 2009 Lonyai Gergely <aleph@mandriva.org> 1.4.5-1mdv2010.1
+ Revision: 477947
- 1.4.5

* Thu Feb 05 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 1.4.4-1mdv2009.1
+ Revision: 337692
- update to new version 1.4.4

* Tue Oct 14 2008 Funda Wang <fwang@mandriva.org> 1.4.3-1mdv2009.1
+ Revision: 293496
- New version 1.4.3

* Wed Aug 06 2008 Thierry Vignaud <tv@mandriva.org> 1.4.1-2mdv2009.0
+ Revision: 264802
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Mon May 19 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 1.4.1-1mdv2009.0
+ Revision: 209083
- new version
- do not re-define stuff
- fix mixture of tabs and spaces
- do not install COPYING files
- spec file clean

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Dec 15 2007 Emmanuel Andry <eandry@mandriva.org> 1.4.0-1mdv2008.1
+ Revision: 120441
- New version
- license is now LGPLv2+
- add major version check
- drop patch2

* Tue Sep 18 2007 Funda Wang <fwang@mandriva.org> 1.2.4-2mdv2008.0
+ Revision: 89577
- New devel package policy


* Fri Feb 02 2007 Andreas Hasenack <andreas@mandriva.com> 1.2.4-1mdv2007.0
+ Revision: 115972
- updated to version 1.2.4

* Wed Dec 13 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.2.3-2mdv2007.1
+ Revision: 96333
- don't make check
- add ppc64 support

* Tue Aug 29 2006 Andreas Hasenack <andreas@mandriva.com> 1.2.3-1mdv2007.0
+ Revision: 58340
- updated to version 1.2.3 (upstream bugfixes)
- bunzipped patch
- Import libgcrypt

* Sun Dec 04 2005 Andreas Hasenack <andreasa@mandriva.com> 1.2.2-1mdk
- updated to version 1.2.2

* Tue Jun 21 2005 Erwan Velu <velu@seanodes.com> 1.2.1-1mdk
- 1.2.1
- Removed patch0 merged upstream
- Removed patch2 : no more necessary

* Tue May 31 2005 Laurent MONTEL <lmontel@mandriva.com> 1.2.0-7mdk
- Fix compile with gcc-4.0

* Fri Mar 11 2005 Stefan van der Eijk <stefan@eijk.nu> 1.2.0-6mdk
- reupload --> lost during ken crash

* Mon Feb 28 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.0-5mdk
- drop lib64 patch in favor of total nuking of -L$(libdir) where
  libdir is a standard library search path, aka fix parallel
  installation when you don't install them at once.

* Wed Feb 09 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.0-4mdk
- lib64/multiarch

* Fri Dec 17 2004 Abel Cheung <deaddog@mandrake.org> 1.2.0-3mdk
- Rebuild

* Thu Aug 19 2004 Abel Cheung <deaddog@deaddog.org> 1.2.0-2mdk
- Rebuild

* Fri May 21 2004 Abel Cheung <deaddog@deaddog.org> 1.2.0-1mdk
- Patch0: automake 1.8 compatibility
- New stable version
- make check
- Use UTF-8 for spec!

* Tue Apr 06 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 1.1.94-1mdk
- Release 1.1.94
- Switch back to gzip archives, since they are signed upstream

